#!/bin/sh
# udhcpc script edited by Tim Riker <Tim@Rikers.org>
#
# IPv6 support added by Alexander Williams <license@unscramble.jp>
#
# GPL-V2 License

echo "start command" $1

[ -z "$1" ] && echo "Error: should be called from udhcpc" && exit 1

RESOLV_CONF="/etc/resolv.conf"
#IP_COMMAND="/usr/local/sbin/ip"
IP_COMMAND="/sbin/ip"

[ -n "$broadcast" ] && BROADCAST="broadcast $broadcast"
[ -n "$subnet" ] && NETMASK="netmask $subnet"

case "$1" in
  deconfig)
    echo "start command /sbin/ifconfig" $interface

    /sbin/ifconfig $interface 0.0.0.0

    echo "start command addr flush" $IP_COMMAND  $interface
    [ -f "$IP_COMMAND" ] && $IP_COMMAND -6 addr flush dev $interface
    #ip -6 addr flush dev rmnet_usb0
    echo "done command"
    ;;


  renew|bound)
    echo "adding ip $ip"
    if [ -n "$subnet_ipv6" ]; then
      $IP_COMMAND -6 addr add ${ip}${subnet_ipv6} dev $interface
    else
      /sbin/ifconfig $interface $ip $BROADCAST $NETMASK
    fi

    /sbin/ifconfig $interface | grep -q "inet addr"

    if [ -n "$router" ] ; then
      echo "deleting routers"
      while route del default gw 0.0.0.0 dev $interface ; do
        :
      done

      [ -n "$subnet_ipv6" ] && $IP_COMMAND -6 route flush dev $interface

      metric=0
      for i in $router ; do
        echo "adding routers $i"
        if [ -n "$subnet_ipv6" ]; then
          route -A inet6 add default gw $i dev $interface metric $((metric++))
        else
          route add default gw $i dev $interface metric $((metric++))
        fi
      done
    fi

    echo -n > $RESOLV_CONF
    [ -n "$domain" ] && echo search $domain >> $RESOLV_CONF
    for i in $dns ; do
      echo "adding dns $i"
      echo nameserver $i >> $RESOLV_CONF
    done
    ;;
esac

exit 0
